/******************************************************************************
 *                       ____    _    _____                                   *
 *                      / ___|  / \  |  ___|    C++                           *
 *                     | |     / _ \ | |_       Actor                         *
 *                     | |___ / ___ \|  _|      Framework                     *
 *                      \____/_/   \_|_|                                      *
 *                                                                            *
 * Copyright (C) 2011 - 2014                                                  *
 * Dominik Charousset <dominik.charousset (at) haw-hamburg.de>                *
 *                                                                            *
 * Distributed under the terms and conditions of the BSD 3-Clause License or  *
 * (at your option) under the terms and conditions of the Boost Software      *
 * License 1.0. See accompanying files LICENSE and LICENCE_ALTERNATIVE.       *
 *                                                                            *
 * If you did not receive a copy of the license files, see                    *
 * http://opensource.org/licenses/BSD-3-Clause and                            *
 * http://www.boost.org/LICENSE_1_0.txt.                                      *
 ******************************************************************************/

#ifndef CAF_CONNECTION_HANDLE_HPP
#define CAF_CONNECTION_HANDLE_HPP

#include "caf/io/handle.hpp"

namespace caf {
namespace io {

/**
 * Generic handle type for identifying connections.
 */
class connection_handle : public handle<connection_handle> {

  friend class handle<connection_handle>;

  using super = handle<connection_handle>;

 public:

  constexpr connection_handle() {}

 private:

  inline connection_handle(int64_t handle_id) : super{handle_id} {}

};

constexpr connection_handle invalid_connection_handle = connection_handle{};

} // namespace io
} // namespace caf

#endif // CAF_CONNECTION_HANDLE_HPP
